
From: "Andi Kleen" <ak@suse.de>

Merged from i386

Signed-off-by: Andi Kleen <ak@suse.de>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/arch/x86_64/kernel/apic.c |    5 +++++
 1 files changed, 5 insertions(+)

diff -puN arch/x86_64/kernel/apic.c~x86_64-dont-sync-apic-arbs-on-p4s arch/x86_64/kernel/apic.c
--- 25/arch/x86_64/kernel/apic.c~x86_64-dont-sync-apic-arbs-on-p4s	2005-01-09 23:01:37.223724240 -0800
+++ 25-akpm/arch/x86_64/kernel/apic.c	2005-01-09 23:01:37.226723784 -0800
@@ -225,6 +225,11 @@ int __init verify_local_APIC(void)
 
 void __init sync_Arb_IDs(void)
 {
+	/* Unsupported on P4 - see Intel Dev. Manual Vol. 3, Ch. 8.6.1 */
+	unsigned int ver = GET_APIC_VERSION(apic_read(APIC_LVR));
+	if (ver >= 0x14)	/* P4 or higher */
+		return;
+
 	/*
 	 * Wait for idle.
 	 */
_
